## kodi-game-libretro-snes9x 1.62.3.53

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(game.libretro.snes9x)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR})

find_package(Kodi REQUIRED)

set(CMAKE_CXX_STANDARD 17)

# CMake on windows only searches for .lib libraries (static library or import library).
# The libretro game library is dynamically loaded so even if an import library would exists it's of no use.
if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  set(_CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_FIND_LIBRARY_SUFFIXES})
  set(CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()
find_library(SNES9X_LIB NAMES snes9x_libretro${CMAKE_SHARED_LIBRARY_SUFFIX} PATH_SUFFIXES libretro)
if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  set(CMAKE_FIND_LIBRARY_SUFFIXES ${_CMAKE_FIND_LIBRARY_SUFFIXES})
endif()

set(SNES9X_CUSTOM_BINARY ${SNES9X_LIB}
    ${PROJECT_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX})

build_addon(${PROJECT_NAME} SNES9X "")

include(CPack)

=== depends/common/snes9x/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(snes9x)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR})

include(ExternalProject)

string(TOUPPER ${PROJECT_NAME} PROJECT_NAME_UC)

set(LIBRETRO_BINARY_DIR libretro)
set(LIBRETRO_SONAME snes9x_libretro${CMAKE_SHARED_LIBRARY_SUFFIX})
set(LIBRETRO_JNISONAME libretro${CMAKE_SHARED_LIBRARY_SUFFIX})

if(CMAKE_BUILD_TYPE MATCHES Debug)
  set(LIBRETRO_DEBUG DEBUG=1)
endif()

if(CORE_SYSTEM_NAME STREQUAL windows)
  find_package(MinGW REQUIRED)
  if(CPU STREQUAL arm64)
    set(MSYSTEM MINGW64)
  else()
    set(MSYSTEM MINGW32)
  endif()
  set(BUILD_COMMAND ${MINGW_MAKE}
                    -j$ENV{NUMBER_OF_PROCESSORS}
                    -C libretro
                    -f Makefile
                    platform=win
                    MSYSTEM=${MSYSTEM}
                     ${LIBRETRO_DEBUG} GIT_VERSION=)
elseif(CORE_SYSTEM_NAME STREQUAL linux)
  set(BUILD_COMMAND $(MAKE)
                    -C libretro
                    -f Makefile
                    platform=unix
                     ${LIBRETRO_DEBUG} GIT_VERSION=)
elseif(CORE_SYSTEM_NAME STREQUAL osx)
  if(CPU STREQUAL arm64)
    set(ARCH arm)
  else()
    set(ARCH intel)
  endif()
  set(BUILD_COMMAND $(MAKE)
                    -C libretro
                    -f Makefile
                    platform=osx
                    arch=${ARCH}
                    CROSS_COMPILE=1
                    LIBRETRO_APPLE_PLATFORM=${CPU}-apple-macos
                    LIBRETRO_APPLE_ISYSROOT=${CMAKE_OSX_SYSROOT}
                     ${LIBRETRO_DEBUG} GIT_VERSION=)
elseif(CORE_SYSTEM_NAME STREQUAL ios OR CORE_SYSTEM_NAME STREQUAL darwin_embedded)
  if(CORE_PLATFORM_NAME STREQUAL ios)
    set(LIBRETRO_SONAME snes9x_libretro_ios${CMAKE_SHARED_LIBRARY_SUFFIX})
    if(CPU STREQUAL arm64)
      set(PLATFORM ios-arm64)
    else()
      set(PLATFORM ios)
    endif()
    set(BUILD_COMMAND IOSSDK=${CMAKE_OSX_SYSROOT} $(MAKE)
                                                  -C libretro
                                                  -f Makefile
                                                  platform=${PLATFORM}
                                                   ${LIBRETRO_DEBUG} GIT_VERSION=)
  elseif(CORE_PLATFORM_NAME STREQUAL tvos)
    set(LIBRETRO_SONAME snes9x_libretro_tvos${CMAKE_SHARED_LIBRARY_SUFFIX})
    set(BUILD_COMMAND IOSSDK=${CMAKE_OSX_SYSROOT} $(MAKE)
                                                  -C libretro
                                                  -f Makefile
                                                  platform=tvos-arm64
                                                   ${LIBRETRO_DEBUG} GIT_VERSION=)
  endif()
elseif(CORE_SYSTEM_NAME STREQUAL android)
  if(NOT NDKROOT)
    message(FATAL_ERROR "${PROJECT_NAME} needs NDKROOT for Android. Missing Toolchain file?")
  endif()
  if(CPU STREQUAL armeabi-v7a OR CPU STREQUAL arm64-v8a)
    set(PLATFORM ${CPU})
  elseif(CPU STREQUAL i686)
    set(PLATFORM x86)
  else()
    message(FATAL_ERROR "${PROJECT_NAME} needs Android ${CPU} build command in CMakeLists.txt!")
  endif()
  set(BUILD_COMMAND GNUMAKE=$(MAKE) ${NDKROOT}/ndk-build
                                    -C libretro/jni
                                    APP_ABI=${PLATFORM}
                                    V7NEONOPTIMIZATION=1
                                    NDK_LIBS_OUT=${PROJECT_SOURCE_DIR}/${LIBRETRO_BINARY_DIR}
                                    V=1
                                     ${LIBRETRO_DEBUG} GIT_VERSION=
                    && cp ${PROJECT_SOURCE_DIR}/${LIBRETRO_BINARY_DIR}/${PLATFORM}/${LIBRETRO_JNISONAME} ${PROJECT_SOURCE_DIR}/${LIBRETRO_BINARY_DIR}/${LIBRETRO_SONAME})
elseif(CORE_SYSTEM_NAME STREQUAL rbpi)
  message(FATAL_ERROR "${PROJECT_NAME} needs RPi build command in CMakeLists.txt!")
elseif(CORE_SYSTEM_NAME STREQUAL freebsd)
  set(BUILD_COMMAND $(MAKE)
                    -C libretro
                    -f Makefile
                    platform=unix
                     ${LIBRETRO_DEBUG} GIT_VERSION=)
else()
  message(FATAL_ERROR "${PROJECT_NAME} - Unknown system: ${CORE_SYSTEM_NAME}")
endif()

externalproject_add(${PROJECT_NAME}
                    SOURCE_DIR ${PROJECT_SOURCE_DIR}
                    PREFIX ${PROJECT_NAME}
                    CONFIGURE_COMMAND ""
                    INSTALL_COMMAND ""
                    BUILD_COMMAND ${BUILD_COMMAND}
                    BUILD_IN_SOURCE 1)

# install the generated shared library
install(FILES ${PROJECT_SOURCE_DIR}/${LIBRETRO_BINARY_DIR}/${LIBRETRO_SONAME}
        DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/libretro RENAME snes9x_libretro${CMAKE_SHARED_LIBRARY_SUFFIX})

=== debian/changelog ===
kodi-game-libretro-snes9x (1.62.3.53-2) bookworm; urgency=low

  * Initial release.

 -- Sébastien Noel <sebastien@twolife.be>  Fri, 28 Feb 2025 14:43:59 +0100

=== debian/control ===
Source: kodi-game-libretro-snes9x
Section: games
Priority: optional
Maintainer: Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat (= 13), cmake, kodi-addons-dev
Standards-Version: 4.7.2

Package: kodi-game-libretro-snes9x
Architecture: any-amd64 any-arm64 any-arm any-i386 any-powerpc any-ppc64 any-ppc64el any-riscv64 any-s390x any-sparc64
Depends: ${shlibs:Depends}, ${misc:Depends}, libretro-snes9x (>= 1.61)
Enhances: kodi
Description: Kodi integration for Snes9x
 Nintendo - SNES / SFC (Snes9x - Current) core for kodi's retroplayer

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	touch fakelib.so
	dh_auto_configure

override_dh_auto_install:
	dh_auto_install
